Package org.eclipse.birt.chart.model

# Interface Chart

All Superinterfaces:
  `org.eclipse.emf.ecore.EObject`, `IChartObject`, `org.eclipse.emf.common.notify.Notifier`

All Known Subinterfaces:
  `ChartWithAxes`, `ChartWithoutAxes`, `DialChart`

All Known Implementing Classes:
  `ChartImpl`, `ChartWithAxesImpl`, `ChartWithoutAxesImpl`, `DialChartImpl`

public interface Chart extends IChartObject
A representation of the model object 'Chart'. Chart is the basic type from which all charts should be extended. It defines the basic elements that are expected to be present for all charts. Class Chart is de facto abstract - never instantiate the class Chart, instantiate one of its extended class ChartWithAxes, ChartWithoutAxes or DialChart instead.

The following features are supported:

- `Version`
- `Type`
- `Sub Type`
- `Description`
- `Block`
- `Dimension`
- `Script`
- `Units`
- `Series Thickness`
- `Grid Column Count`
- `Extended Properties`
- `Sample Data`
- `Styles`
- `Interactivity`
- `Empty Message`

See Also:
  - `ModelPackage.getChart()`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`VERSION`
The current chart version, the number should be modified when chart mode is updated.

## Method Summary

Modifier and Type
Method
Description
`void`
`clearSections(int iSectionType)`
This method walks through the model and clears specific model sections that are not required at deployment time.
`Chart`
`copyInstance()`
`void`
`createSampleRuntimeSeries()`
Builds runtime series instances for each design-time series based on the sample data contained in the model
`Block`
`getBlock()`
Returns the value of the 'Block' containment reference.
`Text`
`getDescription()`
Returns the value of the 'Description' containment reference.
`ChartDimension`
`getDimension()`
Returns the value of the 'Dimension' attribute.
`Label`
`getEmptyMessage()`
Returns the value of the 'Empty Message' containment reference.
`org.eclipse.emf.common.util.EList<ExtendedProperty>`
`getExtendedProperties()`
Returns the value of the 'Extended Properties' containment reference list.
`int`
`getGridColumnCount()`
Returns the value of the 'Grid Column Count' attribute.
`Interactivity`
`getInteractivity()`
Returns the value of the 'Interactivity' containment reference.
`Legend`
`getLegend()`
Convenience method that gets the Legend Block for the chart.
`Plot`
`getPlot()`
Convenience method that gets the Plot Block for the chart.
`SampleData`
`getSampleData()`
Returns the value of the 'Sample Data' containment reference.
`String`
`getScript()`
Returns the value of the 'Script' attribute.
`SeriesDefinition[]`
`getSeriesForLegend()`
This method returns all series whose captions/markers are to be rendered in the Legend content
`double`
`getSeriesThickness()`
Returns the value of the 'Series Thickness' attribute.
`org.eclipse.emf.common.util.EList<StyleMap>`
`getStyles()`
Returns the value of the 'Styles' containment reference list.
`String`
`getSubType()`
Returns the value of the 'Sub Type' attribute.
`TitleBlock`
`getTitle()`
Convenience method that gets the Title Block for the chart.
`String`
`getType()`
Returns the value of the 'Type' attribute.
`String`
`getUnits()`
Returns the value of the 'Units' attribute.
`String`
`getVersion()`
Returns the value of the 'Version' attribute.
`boolean`
`isSetDimension()`
Returns whether the value of the '`Dimension`' attribute is set.
`boolean`
`isSetGridColumnCount()`
Returns whether the value of the ' `Grid Column Count`' attribute is set.
`boolean`
`isSetSeriesThickness()`
Returns whether the value of the ' `Series Thickness`' attribute is set.
`boolean`
`isSetVersion()`
Returns whether the value of the '`Version`' attribute is set.
`void`
`setBlock(Block value)`
Sets the value of the '`Block`' containment reference.
`void`
`setDescription(Text value)`
Sets the value of the '`Description`' containment reference.
`void`
`setDimension(ChartDimension value)`
Sets the value of the '`Dimension`' attribute.
`void`
`setEmptyMessage(Label value)`
Sets the value of the '`Empty Message`' containment reference.
`void`
`setGridColumnCount(int value)`
Sets the value of the '`Grid Column Count`' attribute.
`void`
`setInteractivity(Interactivity value)`
Sets the value of the '`Interactivity`' containment reference.
`void`
`setSampleData(SampleData value)`
Sets the value of the '`Sample Data`' containment reference.
`void`
`setScript(String value)`
Sets the value of the '`Script`' attribute.
`void`
`setSeriesThickness(double value)`
Sets the value of the '`Series Thickness`' attribute.
`void`
`setSubType(String value)`
Sets the value of the '`Sub Type`' attribute.
`void`
`setType(String value)`
Sets the value of the '`Type`' attribute.
`void`
`setUnits(String value)`
Sets the value of the '`Units`' attribute.
`void`
`setVersion(String value)`
Sets the value of the '`Version`' attribute.
`void`
`unsetDimension()`
Unsets the value of the '`Dimension`' attribute.
`void`
`unsetGridColumnCount()`
Unsets the value of the ' `Grid Column Count`' attribute.
`void`
`unsetSeriesThickness()`
Unsets the value of the '`Series Thickness`' attribute.
`void`
`unsetVersion()`
Unsets the value of the '`Version`' attribute.

### Methods inherited from interface org.eclipse.emf.ecore.EObject

`eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eInvoke, eIsProxy, eIsSet, eResource, eSet, eUnset`

### Methods inherited from interface org.eclipse.emf.common.notify.Notifier

`eAdapters, eDeliver, eNotify, eSetDeliver`

## Field Details

### VERSION

static final String VERSION
The current chart version, the number should be modified when chart mode is updated.

See Also:
  - Constant Field Values

## Method Details

### getVersion

String getVersion()
Returns the value of the 'Version' attribute. The default value is `"1.0.0"`. Specifies the version number of this chart.

Returns:
  the value of the 'Version' attribute.
See Also:
  - `isSetVersion()`
  - `unsetVersion()`
  - `setVersion(String)`
  - `ModelPackage.getChart_Version()`

### setVersion

void setVersion(String value)
Sets the value of the '`Version`' attribute.

Parameters:
  `value` - the new value of the 'Version' attribute.
See Also:
  - `isSetVersion()`
  - `unsetVersion()`
  - `getVersion()`

### unsetVersion

void unsetVersion()
Unsets the value of the '`Version`' attribute.

See Also:
  - `isSetVersion()`
  - `getVersion()`
  - `setVersion(String)`

### isSetVersion

boolean isSetVersion()
Returns whether the value of the '`Version`' attribute is set.

Returns:
  whether the value of the 'Version' attribute is set.
See Also:
  - `unsetVersion()`
  - `getVersion()`
  - `setVersion(String)`

### getType

String getType()
Returns the value of the 'Type' attribute. Gets the type of this chart. Specifies the type of this chart.

Returns:
  the value of the 'Type' attribute.
See Also:
  - `setType(String)`
  - `ModelPackage.getChart_Type()`

### setType

void setType(String value)
Sets the value of the '`Type`' attribute. Sets the type of this chart. This is primarily used in the UI to enable re-entrant dialogs.

Parameters:
  `value` - the new value of the 'Type' attribute.
See Also:
  - `getType()`

### getSubType

String getSubType()
Returns the value of the 'Sub Type' attribute. Gets the sub-type of this chart. Specifies the sub-type of this chart.

Returns:
  the value of the 'Sub Type' attribute.
See Also:
  - `setSubType(String)`
  - `ModelPackage.getChart_SubType()`

### setSubType

void setSubType(String value)
Sets the value of the '`Sub Type`' attribute. Sets the sub-type of this chart. This is primarily used in the UI to enable re-entrant dialogs.

Parameters:
  `value` - the new value of the 'Sub Type' attribute.
See Also:
  - `getSubType()`

### getDescription

Text getDescription()
Returns the value of the 'Description' containment reference. Gets the description string for the chart. Description of the chart...could be used as tooltip value for example.

Returns:
  the value of the 'Description' containment reference.
See Also:
  - `setDescription(Text)`
  - `ModelPackage.getChart_Description()`

### setDescription

void setDescription(Text value)
Sets the value of the '`Description`' containment reference. Sets the description string for the chart.

Parameters:
  `value` - the new value of the 'Description' containment reference.
See Also:
  - `getDescription()`

### getBlock

Block getBlock()
Returns the value of the 'Block' containment reference. Gets the `Block`instance for the chart. Defines a virtual entity that is independent of any chart element, but contains them and can be moved around in the chart area for rendering.

Returns:
  the value of the 'Block' containment reference.
See Also:
  - `setBlock(Block)`
  - `ModelPackage.getChart_Block()`

### setBlock

void setBlock(Block value)
Sets the value of the '`Block`' containment reference. Sets the `Block`instance representing the chart as a whole.

Parameters:
  `value` - the new value of the 'Block' containment reference.
See Also:
  - `getBlock()`

### getDimension

ChartDimension getDimension()
Returns the value of the 'Dimension' attribute. The default value is `"Two_Dimensional"`. The literals are from the enumeration `ChartDimension`. Gets the dimensions for the chart. The dimensions here are essentially an indicator of how the chart will appear when rendered and do not have a bearing on the number of variables or facets to the data. Defines the dimensions the chart has.

Returns:
  the value of the 'Dimension' attribute.
See Also:
  - `ChartDimension`
  - `isSetDimension()`
  - `unsetDimension()`
  - `setDimension(ChartDimension)`
  - `ModelPackage.getChart_Dimension()`

### setDimension

void setDimension(ChartDimension value)
Sets the value of the '`Dimension`' attribute. Sets the dimensions for this chart.

Parameters:
  `value` - the new value of the 'Dimension' attribute.
See Also:
  - `ChartDimension`
  - `isSetDimension()`
  - `unsetDimension()`
  - `getDimension()`

### unsetDimension

void unsetDimension()
Unsets the value of the '`Dimension`' attribute.

See Also:
  - `isSetDimension()`
  - `getDimension()`
  - `setDimension(ChartDimension)`

### isSetDimension

boolean isSetDimension()
Returns whether the value of the '`Dimension`' attribute is set.

Returns:
  whether the value of the 'Dimension' attribute is set.
See Also:
  - `unsetDimension()`
  - `getDimension()`
  - `setDimension(ChartDimension)`

### getScript

String getScript()
Returns the value of the 'Script' attribute. Gets the script text associated with the chart. Holds the script for the chart.

Returns:
  the value of the 'Script' attribute.
See Also:
  - `setScript(String)`
  - `ModelPackage.getChart_Script()`

### setScript

void setScript(String value)
Sets the value of the '`Script`' attribute. Sets the script text associated with the chart. For the script contents to be used at runtime a mechanism will need to be in place that understands and can evaluate the contents of the script.

Parameters:
  `value` - the new value of the 'Script' attribute.
See Also:
  - `getScript()`

### getUnits

String getUnits()
Returns the value of the 'Units' attribute. Gets the Units of Measurement being used for this chart. Holds the units of measurement for the model.

Returns:
  the value of the 'Units' attribute.
See Also:
  - `setUnits(String)`
  - `ModelPackage.getChart_Units()`

### setUnits

void setUnits(String value)
Sets the value of the '`Units`' attribute. Sets the Units of Measurement to be used for this chart.

Parameters:
  `value` - the new value of the 'Units' attribute.
See Also:
  - `getUnits()`

### getSeriesThickness

double getSeriesThickness()
Returns the value of the 'Series Thickness' attribute. Gets the series thickness as a percentage. This is the thickness used to render the shape representing the series when the chart is rendered in 3D or 2D with Depth formats. Specifies the thickness to be used while rendering the chart with depth or in 3D.

Returns:
  the value of the 'Series Thickness' attribute.
See Also:
  - `isSetSeriesThickness()`
  - `unsetSeriesThickness()`
  - `setSeriesThickness(double)`
  - `ModelPackage.getChart_SeriesThickness()`

### setSeriesThickness

void setSeriesThickness(double value)
Sets the value of the '`Series Thickness`' attribute. Sets the series thickness as a percentage. This is the thickness used to render the shape representing the series when the chart is rendered in 3D or 2D with Depth formats.

Parameters:
  `value` - the new value of the 'Series Thickness' attribute.
See Also:
  - `isSetSeriesThickness()`
  - `unsetSeriesThickness()`
  - `getSeriesThickness()`

### unsetSeriesThickness

void unsetSeriesThickness()
Unsets the value of the '`Series Thickness`' attribute.

See Also:
  - `isSetSeriesThickness()`
  - `getSeriesThickness()`
  - `setSeriesThickness(double)`

### isSetSeriesThickness

boolean isSetSeriesThickness()
Returns whether the value of the ' `Series Thickness`' attribute is set.

Returns:
  whether the value of the 'Series Thickness' attribute is set.
See Also:
  - `unsetSeriesThickness()`
  - `getSeriesThickness()`
  - `setSeriesThickness(double)`

### getGridColumnCount

int getGridColumnCount()
Returns the value of the 'Grid Column Count' attribute. Specifies the number of columns to use if multiple series are to be plotted in a single chart.

Returns:
  the value of the 'Grid Column Count' attribute.
See Also:
  - `isSetGridColumnCount()`
  - `unsetGridColumnCount()`
  - `setGridColumnCount(int)`
  - `ModelPackage.getChart_GridColumnCount()`

### setGridColumnCount

void setGridColumnCount(int value)
Sets the value of the '`Grid Column Count`' attribute.

Parameters:
  `value` - the new value of the 'Grid Column Count' attribute.
See Also:
  - `isSetGridColumnCount()`
  - `unsetGridColumnCount()`
  - `getGridColumnCount()`

### unsetGridColumnCount

void unsetGridColumnCount()
Unsets the value of the ' `Grid Column Count`' attribute.

See Also:
  - `isSetGridColumnCount()`
  - `getGridColumnCount()`
  - `setGridColumnCount(int)`

### isSetGridColumnCount

boolean isSetGridColumnCount()
Returns whether the value of the ' `Grid Column Count`' attribute is set.

Returns:
  whether the value of the 'Grid Column Count' attribute is set.
See Also:
  - `unsetGridColumnCount()`
  - `getGridColumnCount()`
  - `setGridColumnCount(int)`

### getExtendedProperties

org.eclipse.emf.common.util.EList<ExtendedProperty> getExtendedProperties()
Returns the value of the 'Extended Properties' containment reference list. The list contents are of type `ExtendedProperty`. Holds a generic list of properties (as name-value pairs) for minor extensions to the chart. Preferred way to add properties remains through modification of schema.

Returns:
  the value of the 'Extended Properties' containment reference list.
See Also:
  - `ModelPackage.getChart_ExtendedProperties()`

### getSampleData

SampleData getSampleData()
Returns the value of the 'Sample Data' containment reference. Gets the sample data for the chart. The sample data is used to display the chart at design-time e.g. in the Preview window of the Chart Builder. Holds a collection of sample values for use by the chart. This type is likely to be highly version dependent.

Returns:
  the value of the 'Sample Data' containment reference.
See Also:
  - `setSampleData(SampleData)`
  - `ModelPackage.getChart_SampleData()`

### setSampleData

void setSampleData(SampleData value)
Sets the value of the '`Sample Data`' containment reference.

Parameters:
  `value` - the new value of the 'Sample Data' containment reference.
See Also:
  - `getSampleData()`

### getStyles

org.eclipse.emf.common.util.EList<StyleMap> getStyles()
Returns the value of the 'Styles' containment reference list. The list contents are of type `StyleMap`. Element "Styles" holds a collection of style maps for use by the chart.

Returns:
  the value of the 'Styles' containment reference list.
See Also:
  - `ModelPackage.getChart_Styles()`

### getInteractivity

Interactivity getInteractivity()
Returns the value of the 'Interactivity' containment reference. Element "Interactivity" holds the settings for interactive features.

Returns:
  the value of the 'Interactivity' containment reference.
See Also:
  - `setInteractivity(Interactivity)`
  - `ModelPackage.getChart_Interactivity()`

### setInteractivity

void setInteractivity(Interactivity value)
Sets the value of the '`Interactivity`' containment reference.

Parameters:
  `value` - the new value of the 'Interactivity' containment reference.
See Also:
  - `getInteractivity()`

### getEmptyMessage

Label getEmptyMessage()
Returns the value of the 'Empty Message' containment reference. Element "EmptyMessage" provides the message text to be displayed in the place of plot area when the chart contains no data. By default, it's visibility is false, which indicates if the chart contains no data, the whole chart will be hidden, and no label will be shown.

Returns:
  the value of the 'Empty Message' containment reference.
See Also:
  - `setEmptyMessage(Label)`
  - `ModelPackage.getChart_EmptyMessage()`

### setEmptyMessage

void setEmptyMessage(Label value)
Sets the value of the '`Empty Message`' containment reference.

Parameters:
  `value` - the new value of the 'Empty Message' containment reference.
See Also:
  - `getEmptyMessage()`

### getLegend

Legend getLegend()
Convenience method that gets the Legend Block for the chart. Note: Manually written

Returns:
  Legend The layout block that represents the legend area in the chart.

### getPlot

Plot getPlot()
Convenience method that gets the Plot Block for the chart. Note: Manually written

Returns:
  Plot The layout block that represents the plot area in the chart.

### getTitle

TitleBlock getTitle()
Convenience method that gets the Title Block for the chart. Note: Manually written

Returns:
  TitleBlock The layout block that represents the title area in the chart.

### getSeriesForLegend

SeriesDefinition[] getSeriesForLegend()
This method returns all series whose captions/markers are to be rendered in the Legend content

Returns:
  SeriesDefinition array

### clearSections

void clearSections(int iSectionType)
This method walks through the model and clears specific model sections that are not required at deployment time.

Parameters:
  `iSectionType` - Possible values are IConstants.RUN_TIME and IConstants.USER_INTERFACE

### createSampleRuntimeSeries

void createSampleRuntimeSeries()
Builds runtime series instances for each design-time series based on the sample data contained in the model

### copyInstance

Chart copyInstance()

Specified by:
  `copyInstance` in interface `IChartObject`